{% if item.key == "default" %}
server {
    listen        		{{ item.value.listen | default(80) }} default_server;
    listen   			[::]:{{ item.value.listen | default(80) }} default_server;
    server_name 		_;
    return        		444; # (No Response)

    access_log 			/var/log/nginx/{{ item.key }}_access.log;
    error_log 			/var/log/nginx/{{ item.key }}_error.log error;

}

{% else %}
upstream {{ item.key }}_backend  {
{% for upstream in item.value.upstreams %}
    server 			{{upstream.backend_address}}:{{upstream.backend_port}};
{% endfor %}
}

server {
   listen         		{{ item.value.listen | default(80) }};
   listen    			[::]:{{ item.value.listen | default(80) }};
   server_name    		{{ item.value.domains | join(' ') }};

   location / {
      proxy_pass 		{{ item.value.upstreams_protocole }}{{ item.key }}_backend;

      client_max_body_size 	{{ item.value.client_max_body_size | default('50M') }};
      proxy_read_timeout 	{{ item.value.proxy_read_timeout | default('300') }};
      proxy_connect_timeout 	{{ item.value.proxy_read_timeout | default('1800') }};
      proxy_set_header 		Upgrade $http_upgrade;
      proxy_set_header 		Connection "upgrade";
      proxy_set_header    	Host $host;
      proxy_set_header 		X-Real-IP $remote_addr;
      proxy_set_header 		X-Forwarded-For $proxy_add_x_forwarded_for;
      proxy_set_header 		X-Forwarded-Proto $scheme;
      proxy_set_header 		X-Frame-Options SAMEORIGIN;

      proxy_ssl_trusted_certificate /etc/ssl/trusted_ca/interhop_ca.crt;
      proxy_ssl_protocols 	TLSv1 TLSv1.1 TLSv1.2;
      proxy_ssl_ciphers 	ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384;

      proxy_ssl_verify        	on;
      proxy_ssl_name 		$host;
      proxy_ssl_verify_depth  	2;
      proxy_ssl_session_reuse	on;

   }

   access_log 			/var/log/nginx/{{ item.key }}_access.log;
   error_log 			/var/log/nginx/{{ item.key }}_error.log error;

}
{% endif %}
